package iup.app;
import org.relaxng.datatype.*;
import org.relaxng.datatype.helpers.StreamingValidatorImpl;
public class TypeTelephone implements Datatype {
  public boolean isValid(String literal, ValidationContext context) {
    // la mthode principale
    // 66 66 66 66 66
    if(literal.length()!=14)
      return false;
    for(int i=0;i<5;i++) {
      int j=3*i;
      if(!Character.isDigit(literal.charAt(j))) return false;
      if(!Character.isDigit(literal.charAt(j+1))) return false;
      if(i>=4) break;
      if(literal.charAt(j+2)!=' ') return false;
    }
    return true;
  }
  // mthodes assez techniques sans intrt en premire approche
  public DatatypeStreamingValidator 
    createStreamingValidator(ValidationContext context) {
    return new StreamingValidatorImpl(this, context);
  }
  public Object createValue(String literal, ValidationContext context) {
    if (!isValid(literal, context))
      return null;
    return literal;
  }
  public boolean sameValue(Object obj1, Object obj2) {
    return obj1.equals(obj2);
  }
  public int valueHashCode(Object obj) {
    return obj.hashCode();
  }
  public int getIdType() {
    return ID_TYPE_NULL;
  }
  public boolean isContextDependent() {
    return false;
  }
  public void checkValid(String literal, ValidationContext context)
    throws DatatypeException {
    if (!isValid(literal, context))
      throw new DatatypeException();
  }
}
